package jp.gr.java_conf.abagames.util;

/**
  Cordinate chcanged into the angle
  */
public class DegUtil {
  final static private int DIV = 360;
  static int[] tantab = new int[258];

  static {
    int i, d=0;
    double od = Math.PI*2 / DIV;
    for ( i=0 ; i<256 ; i++ ) {
      while ( (int)(Math.sin(d*od)/Math.cos(d*od)*256)<i ) d++;
      tantab[i] = d;
    }
    tantab[256] = 128;
    tantab[257] = 128;
  }

  static public int getDeg(float fx, float fy) {
    int x = (int)(fx*256), y = (int)(fy*256);
    int tx, ty;
    int f, od, tn;

    if ( x==0 && y==0 ) {
      return(0);
    }

    if ( x < 0 ) {
      tx = -x;
      if ( y < 0 ) {
        ty = -y;
        if ( tx > ty ) {
          f = 1;
          od = DIV*3/4; tn = ty*256/tx;
        } else {
          f = -1;
          od = DIV; tn = tx*256/ty;
        }
      } else {
        ty = y;
        if ( tx > ty ) {
          f = -1;
          od = DIV*3/4; tn=ty*256/tx;
        } else {
          f=1;
          od = DIV/2; tn=tx*256/ty;
        }
      }
    } else {
      tx = x;
      if ( y < 0 ) {
        ty = -y;
        if ( tx > ty ) {
          f = -1;
          od = DIV/4; tn = ty*256/tx;
        } else {
          f = 1;
          od = 0; tn = tx*256/ty;
        }
      } else {
        ty = y;
        if ( tx > ty ) {
          f = 1;
          od = DIV/4; tn = ty*256/tx;
        } else {
          f = -1;
          od = DIV/2; tn = tx*256/ty;
        }
      }
    }
    return(od+tantab[tn]*f);
  }
}

